require "dynamicAI/version"

##############################################################################################
#                                INFINITE LEARNING LOOP                                      #
##############################################################################################
# Think of this as an infinite learning algorithm. You program an action in behaviours, or   #
# a list of possible behaviours. Even if the list of behaviours changes ( is rewritten ), it #
# stores a memory of the last action it performed, and can repeat that action even though    #
# it no longer has that script type in its known behaviour list.                             #
##############################################################################################

module DynamicAI
  class Error < StandardError; end
  
  class Generate
    def self.behaviours
      old_action = File.read("data/action/history.txt")

      # Creates a list of behaviours the AI does.
      behaviours = File.readlines("data/script/behaviours.txt")

      # Determines a reset limit based on the maximum behaviour list size.
      size_limit_file = behaviours.size.to_i
      size_limit      = size_limit_file - 1

      # Takes an input from a number file.
      number     = File.read("data/input/number.txt").strip.to_i

      # If the number file exceeds the size limit, reset to zeo.
      if number > size_limit
        number = 0
      end

      # Dettermines the action to be written to file and ran.
      new_action = behaviours[number]

      # Writes the action to a temp ruby.
      open("temp.rb", "w") { |f|
        f.puts new_action
        f.puts old_action
      }

      # Append new action to old_action.
      open("data/action/history.txt", "w") { |f|
        f.puts new_action
        f.puts old_action
      }

      # Add one increment to number file.
      open("data/input/number.txt", "w") { |f|
        f.puts number = number + 1
      }
    end
  end

  class Operate
    def self.written_script
      system("ruby temp.rb")
    end

    def self.purge_script
      system("shred --remove temp.rb")
    end
  end
end
